// 8954705f-dcfd-423a-b196-fd4193eba2c2

function NeutrinoEffect(ctx) {

	var Db = this;

	var ne = function (Ld, Bd) {
		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0) {
			this.we = this.Bd.we.pe[0];

			this.Lc = [ne.prototype.Ec,
				ne.prototype.Fc][this.we.xe];
		}
		else
			this.we = null;
	}

	ne.prototype = {
		Ec: function (fe, Ab, Xb) {
			var Gc = ctx.ib(Xb.Md);
			var Hc = Math.cos(Gc);
			var Ic = Math.sin(Gc);
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(ye * Hc, ye * Ic, ze * -Ic, ze * Hc, Ab[0], Ab[1]);
		},

		Fc: function (fe, Ab, Xb) {
			var q = Xb.Mc;
			var z2 = 2.0 * q[2] * q[2];
			var xy = 2.0 * q[0] * q[1];
			var wz = 2.0 * q[3] * q[2];
			var ye = ctx.Ae(Xb.Nd[0]);
			var ze = ctx.Ae(Xb.Nd[1]);
			fe./**/transform(
				ye * (1.0 - 2.0 * q[1] * q[1] - z2),
				ye * (xy + wz),
				ze * (wz - xy),
				ze * (2.0 * q[0] * q[0] + z2 - 1.0),
				Ab[0], Ab[1]);
		},

		Pc: function (fe, Xb, ge) {
			Xb.vc(fe, -1, ge);

			if (this.we) {

				if (this.Be != null && !Xb.oc) {

					if (Xb.Od > 0.001) {
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Ab = Xb.Ab.slice();
						var Nd = Xb.Nd.slice();
						if (!ge || ge./**/transform(Ab, Nd)) {

							var df = Math.abs(Nd[0]);
							var ef = Math.abs(Nd[1]);

							if (df > 0.001 && ef > 0.001) {						
								fe.save();
								this.Lc(fe, Ab, Xb);
								
								fe.translate(-df * Xb.Pd[0], -ef * (1 - Xb.Pd[1]));
								fe.globalAlpha = Xb.Od;

								if (Xb.gf[0] < 0.999 || Xb.gf[1] < 0.999 || Xb.gf[2] < 0.999) {

									var Ye = df < this.Tc ? df : this.Tc;
									var Ze = ef < this.Uc ? ef : this.Uc;

									ctx.af(Ye, Ze);

									ctx.bf.globalCompositeOperation = "copy";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "multiply";
									ctx.bf.fillStyle = ctx.ff(Xb.gf);
									ctx.bf.fillRect(0, 0, Ye, Ze);

									ctx.bf.globalCompositeOperation = "destination-atop";
									ctx.bf.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc,
										0, 0, Ye, Ze);

									fe.drawImage(ctx.cf, 0, 0, Ye, Ze, 0, 0, df, ef);
								}
								else {
									fe.drawImage(this.Be.image,
										this.Be.x + this.Tc * De, this.Be.y + this.Uc * Ee,
										this.Tc, this.Uc, 0, 0, df, ef);
								}

								fe.restore();
							}
						}
					}
				}
			}

			Xb.vc(fe, 1, ge);
		},

		Hd: function (fe, ge) {
			fe.save();

			if (this.we) {
				fe.globalCompositeOperation = this.Ld.materials[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].materialIndex];
				this.Be = this.Ld.textureDescs[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
			}
			else {
				this.Be = null;
			}

			if (this.Be) {
				this.Tc = this.Be.width / this.we.Rc;
				this.Uc = this.Be.height / this.we.Sc;
			}

			function kd(a, b) {
				if (a.Ab[2] < b.Ab[2])
					return 1;
				if (a.Ab[2] > b.Ab[2])
					return -1;
				return 0;
			}

			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
				case 2:
					this.Bd.tc.sort(kd);

					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.Pc(fe, this.Bd.tc[Wb], ge);
					}
					break;
			}

			fe.restore();
		}
	}

	var oe = function (Ld, Bd) {

		this.Ld = Ld;
		this.Bd = Bd;

		if (this.Bd.we.pe.length > 0)
			this.we = this.Bd.we.pe[0];
		else
			this.we = null;

		this.vertex = [
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] },
			{ /**/position: [0.0, 0.0, 0.0], /**/color: [0, 0, 0, 0], /**/texCoords: [[0.0, 0.0]] }];
	}

	oe.prototype = {
		qe: function (Xb, se, re, te, renderBuffer) {
			Xb.Ce(-1, se, re, te, renderBuffer);

			if (this.we) {

				if (!Xb.oc) {

					var v0 = this.vertex[0];
					var v1 = this.vertex[1];
					var v2 = this.vertex[2];
					var v3 = this.vertex[3];

					var Fe = [], Ge = [];

					if (this.we.xe == 0) {
						var a = ctx.ib(Xb.Md);
						var s = Math.sin(a);
						var c = Math.cos(a);

						Fe[0] = se[0] * c + re[0] * s;
						Fe[1] = se[1] * c + re[1] * s;
						Fe[2] = se[2] * c + re[2] * s;

						Ge[0] = -se[0] * s + re[0] * c;
						Ge[1] = -se[1] * s + re[1] * c;
						Ge[2] = -se[2] * s + re[2] * c;
					}
					else {
						var q = Xb.Mc;
						var z2 = 2.0 * q[2] * q[2];
						var xy = 2.0 * q[0] * q[1];
						var wz = 2.0 * q[3] * q[2];

						Fe[0] = 1.0 - 2.0 * q[1] * q[1] - z2;
						Fe[1] = xy + wz;
						Fe[2] = 2.0 * q[0] * q[2] - 2.0 * q[3] * q[1];

						Ge[0] = xy - wz;
						Ge[1] = 1.0 - 2.0 * q[0] * q[0] - z2;
						Ge[2] = 2.0 * q[1] * q[2] + 2.0 * q[3] * q[0];
					}

					var He = [], Ie = [], Je = [], Ke = [];
					ctx.u(He, Fe, -Xb.Nd[0] * Xb.Pd[0]);
					ctx.u(Ie, Fe, Xb.Nd[0] * (1.0 - Xb.Pd[0]));
					ctx.u(Je, Ge, -Xb.Nd[1] * Xb.Pd[1]);
					ctx.u(Ke, Ge, Xb.Nd[1] * (1.0 - Xb.Pd[1]));

					ctx.c(v0./**/position, He, Je);
					ctx.c(v0./**/position, v0./**/position, Xb.Ab);
					ctx.c(v1./**/position, He, Ke);
					ctx.c(v1./**/position, v1./**/position, Xb.Ab);
					ctx.c(v2./**/position, Ie, Ke);
					ctx.c(v2./**/position, v2./**/position, Xb.Ab);
					ctx.c(v3./**/position, Ie, Je);
					ctx.c(v3./**/position, v3./**/position, Xb.Ab);

					{
						var rgb = ctx.v(Xb.gf, 255);
						v0./**/color = v1./**/color = v2./**/color = v3./**/color = [rgb[0], rgb[1], rgb[2], Xb.Od * 255];
					}

					{
						var De = Math.floor(Xb.Qc % this.we.Rc);
						var Ee = Math.floor(Xb.Qc / this.we.Rc);

						var Pe, Qe, Re, Se;

						var We = this.Ld.texturesRemap[this.Ld./**/model.renderStyles[this.we.renderStyleIndex].textureIndices[0]];
						if (We) {
							var Ue = We.width / this.we.Rc;
							var Ve = We.height / this.we.Sc;

							var Pe = We.x + De * Ue;
							var Qe = Pe + Ue;
							var Re = (We.y + We.height - Ee * Ve);
							var Se = Re - Ve;
						} else {
							var Ue = 1.0 / this.we.Rc;
							var Ve = 1.0 / this.we.Sc;

							var Pe = De * Ue;
							var Qe = Pe + Ue;
							var Re = (1.0 - Ee * Ve);
							var Se = Re - Ve;
						}

						v0./**/texCoords[0] = [Pe, Se];
						v1./**/texCoords[0] = [Pe, Re];
						v2./**/texCoords[0] = [Qe, Re];
						v3./**/texCoords[0] = [Qe, Se];
					}

					renderBuffer.pushVertex(v0);
					renderBuffer.pushVertex(v1);
					renderBuffer.pushVertex(v2);
					renderBuffer.pushVertex(v3);

					if (!renderBuffer.__lastRenderCall) {
						renderBuffer.__lastRenderCall = new ctx.RenderCall(0, 6, this.we.renderStyleIndex);
					} else {
						var lastRenderCall = renderBuffer.__lastRenderCall;

						if (lastRenderCall.renderStyleIndex == this.we.renderStyleIndex) {
							lastRenderCall.numIndices += 6;
						} else {
							renderBuffer.pushRenderCall(lastRenderCall);
							renderBuffer.__lastRenderCall = new ctx.RenderCall(
								lastRenderCall.startIndex + lastRenderCall.numIndices,
								6, this.we.renderStyleIndex);
						}
					}
				}
			}

			Xb.Ce(1, se, re, te, renderBuffer);
		},

		ue: function (se, re, te, renderBuffer) {
			switch (this.Bd.Vc) {
				case 0:
					for (var Wb = 0; Wb < this.Bd.tc.length; ++Wb) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 1:
					for (var Wb = this.Bd.tc.length; Wb-- > 0;) {
						this.qe(this.Bd.tc[Wb], se, re, te, renderBuffer);
					}
					break;

				case 2:
					this.Bd.tc.forEach(function (Xb) {
						Xb.depth = ctx.H(te, Xb.Ab);
					});

					this.Bd.tc.sort(function (a, b) {
						if (a.depth < b.depth)
							return 1;
						if (a.depth > b.depth)
							return -1;
						return 0;
					});

					this.Bd.tc.forEach(function (Xb) {
						this.qe(Xb, se, re, te, renderBuffer);
					}, this);
					break;
			}
		}
	}

	var ld = function (Ld, we, ve) {
		var Vb = this;
		this.Ld = Ld;
		this.we = we;

		// Eb

		function Eb() {
			this.Fb = 0;
			this.Gb = 1;
			this.Hb = null;
			this.Ib = null;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.Ob = this.Gb;
				this.Fb = 0;
			}

			this.Nb();
		}

		Eb.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var Rb = Vb.Rb;
				var systemTime = Ld.Rb;
				var Sb = Qb;
				var ic = 0;

				if (this.zb > 0.000001) {

					var Tb = this.Ob + Qb * this.zb;

					while (Tb >= 1.0) {
						var Ub = this.zb < 0.001 ? 0.0 : (1.0 - this.Ob) / this.zb;
						Sb -= Ub;
						Rb += Ub;
						systemTime += Ub;

						if (this.Hb != null && Rb > this.Hb) {
							Vb.disactivate();
							break;
						}

						Vb.Rb = Rb;
						Ld.Rb = systemTime;

						if (Ab && Qb > 0)
							ctx.ab(Vb.Ab, Ab, Vb.Bb, Sb / Qb);

						if (Mc && Qb > 0)
							ctx.slerpq(Vb.Mc, Mc, Vb.prevRotation, Sb / Qb);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Sb);
							++ic;
						}

						this.Ob = 0.0;
						Tb -= 1.0;

						if (this.Ib != null && ++this.Fb >= this.Ib) {
							Vb.disactivate();
							break;
						}
					}

					this.Ob = Tb;
				}
				Rb += Sb;
				Vb.Rb = Rb;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.T(Vb.Mc, Mc);

				return ic;
			}
		}

		// ac

		function ac() {
			this.Gb = 1;
			this.Kb = 0;
			this.Lb = 1;

			Vb.we.Mb(this); // IMPL

			this.Nb = function () {
				this.bc = this.Gb;
			}

			this.Nb();
		}

		ac.prototype = {
			Jd: function () {
				this.Nb();
			},

			Id: function (Qb, Ab, Mc) {
				Vb.we.Pb(Qb, Vb, this); // IMPL

				var cc = Vb.Rb;
				var dc = cc + Qb;
				var systemTimeBeforeFrame = Ld.Rb;
				var systemTimeAfterFrame = systemTimeBeforeFrame + Qb;
				var ec = Ab ? ctx.O(ctx.h(Ab, Vb.Bb)) : 0;
				var ic = 0;

				if (ec > 0.000001) {
					var fc = ec / this.rd;
					var Tb = this.bc + fc;

					var hc = fc < 0.001 ?
						1.0 - this.bc : (1.0 - this.bc) / fc;

					var jc = [];
					var currentEmitterRot = [];

					while (Tb > 1.0) {
						var kc = cc + hc * Qb;

						if (Ab)
							ctx.ab(jc, Vb.Bb, Ab, hc);

						if (Mc)
							ctx.slerpq(currentEmitterRot, Vb.prevRotation, Mc, hc);

						Vb.Rb = kc;
						ctx.T(Vb.Ab, jc);
						Ld.Rb = ctx.X(systemTimeBeforeFrame, systemTimeAfterFrame, hc);

						// for the future when Jb would be external
						this.Lb = this.Jb;

						for (var Wb = 0; Wb < this.Jb; ++Wb) {
							if (Vb.sc.length == 0)
								break;

							if (this.Jb == 1)
								this.Kb = 0;
							else
								this.Kb = Wb / (this.Jb - 1);

							var Xb = Vb.sc.pop();
							Vb.tc.unshift(Xb);

							if (Wb == 0)
								Xb.Yb();
							else
								Xb.Zb();

							Xb.Id(Qb * (1.0 - hc));
							++ic;
						}

						hc += 1.0 / fc;
						Tb -= 1.0;
					}

					this.bc = Tb;
				}

				Vb.Rb = dc;

				if (Ab)
					ctx.T(Vb.Ab, Ab);

				if (Mc)
					ctx.U(Vb.Mc, Mc);

				return ic;
			}
		}

		// mc

		function mc() {
			this.Ab = [];
			this.Pd = [];
			this.Nd = [];
			this.gf = [];
			this.Kc = [];
		}

		mc.prototype = {
			nc: function () {
				this.oc = false;

				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];
					pc.Bd.Jd(this.Ab, null);

					if (pc.Ad.sd)
						pc.Bd.disactivate();
				}
			},

			Yb: function () {
				Vb.we.fd(Vb, this); // IMPL
				this.nc();
			},

			Zb: function () {
				Vb.we.gd(Vb, this); // IMPL
				this.nc();
			},

			Id: function (Qb) {
				Vb.we.qc(Qb, Vb, this); // IMPL

				this.rc(Qb);
			},

			pc: function (je) {
				return this.Kc[je].Bd;
			},

			rc: function (Qb) {
				for (var i = 0; i < this.Kc.length; i++) {
					this.Kc[i].Bd.Id(Qb, this.Ab, null);
				}
			},

			uc: function (md, nd) {
				this.Kc.push({
					Bd: new ld(Ld, md, ve),
					Ad: nd
				});
			},

			vc: function (fe, xc, ge) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.Hd(fe, ge);
				}
			},

			Ce: function (xc, se, re, te, renderBuffer) {
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (xc == pc.Ad.xc)
						pc.Bd.ue(se, re, te, renderBuffer);
				}
			},

			wc: function (fe) {
				this.oc = true;
				for (var i = 0; i < this.Kc.length; ++i) {
					var pc = this.Kc[i];

					if (pc.Ad.sd)
						pc.Bd.activate();
					else
						pc.Bd.disactivate();
				}
			},

			yc: function (Gd) {
				for (var i = 0; i < this.Kc.length; ++i) {
					this.Kc[i].Bd.Ed(Gd);
				}
			}
		}

		// zc

		function zc() {
		}

		zc.prototype.Ac = function (Xb) {
			return Vb.we.Cc(Vb, Xb, this); // IMPL
		}

		// ld Ad

		this.Ab = [];
		this.Bb = [];
		this.Mc = [];
		this.prevRotation = [];
		this.tc = [];
		this.sc = [];
		this.Wc = new zc();
		this.construct = new ve(this.Ld, this);
		this.Yc = [];
		this.ad = [];

		this.dd = function () {
			this.vd = new Eb();
		}

		this.ed = function () {
			this.vd = new ac();
		}

		this.we.ud(this); // IMPL

		for (var Wb = 0; Wb < this.jd; ++Wb) {
			var Xb = new mc();

			for (var id = 0; id < this.Yc.length; ++id) {
				var hd = this.Yc[id];
				Xb.uc(hd.Db, hd.Ad);
			}

			this.sc.push(Xb);
		}

		this.Nb = function (Ab, Mc) {

			ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
			ctx.T(this.Bb, this.Ab);
			ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			ctx.U(this.prevRotation, this.Mc);

			this.Rb = 0.0;
			this.wd = 0.0;
			this.Zc = true;
			this.paused_ = false;
			this.generatorsPaused_ = false;
			ctx.W(this.ad, 0, 0, 0);
		}
	}

	ld.prototype.Jd = function (Ab, Mc) {
		this.Nb(Ab, Mc);

		this.sc.push.apply(this.sc, this.tc);
		this.tc.length = 0;

		this.vd.Jd();
	}

	ld.prototype.Id = function (Qb, Ab, Mc) {

		if (this.paused_)
		{
			this.Td(Ab, Mc);
			return;
		}

		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			if (Qb > 0.0001) {
				var shift = [];
				ctx.g(shift, Ab, this.Bb);
				ctx.T(this.ad, shift);
				ctx.w(this.ad, this.ad, Qb);
			}
			else {
				ctx.W(this.ad, 0, 0, 0);
			}
		}
		else {
			ctx.W(this.ad, 0, 0, 0);
		}

		if (Mc)
		{
			ctx.U(this.prevRotation, this.Mc);
		}

		var ic;

		if (this.Zc && !this.generatorsPaused_) {
			ic = this.vd.Id(Qb, Ab, Mc);
		}
		else {
			if (Ab)
				ctx.T(this.Ab, Ab);

			if (Mc)
				ctx.U(this.Mc, Mc);

			ic = 0;
			this.Rb += Qb;
		}

		for (var Wb = ic; Wb < this.tc.length;) {
			var Xb = this.tc[Wb];

			if (!Xb.oc) {
				Xb.Id(Qb);

				if (this.Wc.Ac(this.tc[Wb])) {
					Xb.wc();

					if (this.xd(Wb))
						continue;
				}
			}
			else {
				Xb.rc(Qb);

				if (this.xd(Wb))
					continue;
			}

			++Wb;
		}
	};

	ld.prototype.xd = function (je) {
		var Xb = this.tc[je];

		var ready = true;

		for (var id = 0; id < Xb.Kc.length; ++id) {
			var Bd = Xb.Kc[id].Bd;

			if (Bd.activated() || Bd.tc.length > 0) {
				ready = false;
				break;
			}
		}

		if (ready) {
			this.sc.push(this.tc[je]);
			this.tc.splice(je, 1);
			return true;
		}

		return false;
	}

	ld.prototype.Hd = function (fe, ge) {
		this.construct.Hd(fe, ge);
	}

	ld.prototype.ue = function (se, re, te, renderBuffer) {
		this.construct.ue(se, re, te, renderBuffer);
	}

	ld.prototype.Td = function (Ab, Mc) {
		this.wd = this.Rb;

		if (Ab) {
			ctx.T(this.Bb, this.Ab);
			ctx.T(this.Ab, Ab);
		}

		if (Mc) {
			ctx.U(this.prevRotation, this.Mc);
			ctx.U(this.Mc, Mc);
		}
	}

	ld.prototype.uc = function (md, nd) {
		this.Yc.push({ Db: md, Ad: nd });
	}

	ld.prototype./**/pause = function () {
		this.paused_ = true;
	}

	ld.prototype./**/unpause = function () {
		this.paused_ = false;
	}

	ld.prototype./**/paused = function () {
		return this.paused_;
	}

	ld.prototype./**/pauseGenerators = function () {
		this.generatorsPaused_ = true;
	}

	ld.prototype./**/unpauseGenerators = function () {
		this.generatorsPaused_ = false;
	}

	ld.prototype./**/generatorsPaused = function () {
		return this.generatorsPaused_;
	}

	ld.prototype.activate = function () {
		this.Zc = true;
	}

	ld.prototype.disactivate = function () {
		this.Zc = false;
	}

	ld.prototype.activated = function () {
		return this.Zc;
	}
	
	ld.prototype./**/getNumParticles = function () {
		return this.tc.length;
	}

	var ke = function () {
		var Cb = this;

		this._init = function (we, Ab, Mc, ve) {
			this./**/model = we;

			this.Ab = [];
			this.Mc = [];

			// ke Ad

			this.od = [];

			this.pd = function (md) {
				var Bd = new ld(this, md, ve);
				Bd.Nb(this.Ab, this.Mc);
				this["_".concat(md.name)] = Bd;
				this.od.push(Bd);
			}

			this.Nb = function (Ab, Mc) {
				this.Cd = 0.0;
				this.Rb = 0.0;
				ctx.T(this.Ab, Ab ? Ab : [0, 0, 0]);
				ctx.U(this.Mc, Mc ? Mc : [0, 0, 0, 1]);
			}

			this.Nb(Ab, Mc);
			this./**/model.qd(this); // IMPL
			this.zeroUpdate();
			this./**/update(this.Ud, Ab, Mc);
		}
	}

	ke.prototype./**/restart = function (/**/position, /**/rotation) {

		this.Nb(/**/position ? /**/position : this.Ab, /**/rotation ? /**/rotation : this.Mc);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Jd(this.Ab, this.Mc);
		}

		this.zeroUpdate();

		this./**/update(this.Ud, this.Ab, this.Mc);
	}

	ke.prototype.zeroUpdate = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Id(0, this.Ab, this.Mc);
		}
	}

	ke.prototype./**/update = function (/**/dt, /**/position, /**/rotation) {
		var updatedTime = 0.0;
		var hc = [];
		ctx.T(hc, this.Ab);
		var frameRotation = [];
		ctx.U(frameRotation, this.Mc);

		if (/**/position && ctx.equalv3_(/**/position, this.Ab))
			/**/position = null;

		if (/**/rotation && ctx.equalq_(/**/rotation, this.Mc))
			/**/rotation = null;

		while ((/**/dt - updatedTime) + this.Cd >= this.Dd) {
			var cc = this.Rb;

			if (/**/position)
				ctx.ab(hc, this.Ab, /**/position, updatedTime / /**/dt);

			if (/**/rotation)
				ctx.slerpq(frameRotation, this.Mc, /**/rotation, updatedTime / /**/dt);

			for (var i = 0; i < this.od.length; ++i) {
				this.od[i].Id(this.Dd, hc, frameRotation);

				this.Rb = cc;
			}

			updatedTime += this.Dd - this.Cd;
			this.Cd = 0.0;
			this.Rb = cc + this.Dd;
		}

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		this.Cd += /**/dt - updatedTime;
	}

	ke.prototype./**/resetPosition = function (/**/position, /**/rotation) {

		if (/**/position)
			ctx.T(this.Ab, /**/position);

		if (/**/rotation)
			ctx.U(this.Mc, /**/rotation);

		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Td(this.Ab, this.Mc);
		}
	}

	ke.prototype./**/setPropertyInAllEmitters = function (/**/name, /**/value) {
		var propName = "_".concat(/**/name);

		if (/**/value instanceof Array) {
			if (/**/value.length == 2) {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.S(this.od[i][propName], /**/value);
				}
			}
			else {
				for (var i = 0; i < this.od.length; ++i) {
					ctx.T(this.od[i][propName], /**/value);
				}
			}
		}
		else {
			for (var i = 0; i < this.od.length; ++i) {
				this.od[i][propName] = /**/value;
			}
		}
	}

	ke.prototype./**/pauseAllEmitters = function() {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pause();
		}
	}

	ke.prototype./**/unpauseAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpause();
		}
	}

	ke.prototype./**/areAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].paused())
				return false;
		}
		return true;
	}

	ke.prototype./**/pauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/pauseGenerators();
		}
	}

	ke.prototype./**/unpauseGeneratorsInAllEmitters = function () {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i]./**/unpauseGenerators();
		}
	}

	ke.prototype./**/areGeneratorsInAllEmittersPaused = function () {
		for (var i = 0; i < this.od.length; ++i) {
			if (!this.od[i].generatorsPaused())
				return false;
		}
		return true;
	}

	ke.prototype./**/getNumParticles = function() {
		var numParticles = 0;
		
		for (var i = 0; i < this.od.length; ++i) {
			numParticles += this.od[i].getNumParticles();
		}
		
		return numParticles;
	}
	

	var le = function () {
		this._init = function (we, Ab, Mc, renderBuffer) {
			le.prototype._init.call(this, we, Ab, Mc, oe);

			this.texturesRemap = [];

			var indices = [];

			{
				var verDisp;
				for (var Wb = 0; Wb < this./**/model.Xe; ++Wb) {
					verDisp = Wb * 4;
					indices.push(verDisp + 0, verDisp + 3, verDisp + 1, verDisp + 1, verDisp + 3, verDisp + 2);
				}
			}

			this.renderBuffer = renderBuffer;
			this.renderBuffer.initialize(this./**/model.Xe * 4, [2], indices, this./**/model.Xe);
			this.renderBuffer.__numIndices = 0;
		}
	}

	le.prototype = new ke();

	le.prototype./**/fillGeometryBuffers = function (/**/cameraRight, /**/cameraUp, /**/cameraDir) {
		this.renderBuffer.cleanup();
		this.renderBuffer.__lastRenderCall = null;

		this.od.forEach(function (Bd) {
			Bd.ue(/**/cameraRight, /**/cameraUp, /**/cameraDir, this.renderBuffer);
		}, this);

		if (this.renderBuffer.__lastRenderCall)
			this.renderBuffer.pushRenderCall(this.renderBuffer.__lastRenderCall);
	}

	var me = function () {
		this._init = function (we, Ab, Mc) {
			me.prototype._init.call(this, we, Ab, Mc, ne);

			this.materials = [];
			this./**/model.materials.forEach(function (value) {
				this.materials.push(['source-over', 'lighter', 'multiply'][value]);
			}, this);

			this./**/textureDescs = [];
		}
	}

	me.prototype = new ke();

	me.prototype./**/draw = function (/**/context, /**/camera) {
		for (var i = 0; i < this.od.length; ++i) {
			this.od[i].Hd(/**/context, /**/camera);
		}
	}

	this.createWGLInstance = function (/**/position, /**/rotation, /**/renderBuffer) {
		var Ld = new le();
		Ld._init(this, /**/position, /**/rotation, /**/renderBuffer);
		return Ld;
	}

	this.createCanvas2DInstance = function (/**/position, /**/rotation) {
		var Ld = new me();
		Ld._init(this, /**/position, /**/rotation);
		return Ld;
	}
	this.textures = ['growing.png'];
	this.materials = [0];
	this.renderStyles = [{materialIndex:0,textureIndices:[0]}];
	this.Xe = 1000;

	function Emitter_Tale() {

		var _3=[], _3x=[], _3y=[], _3z=[], _5, _7, _8, _8i0, _8s0 = [], _10=[], _10fs=[], _10vs=[], _10rw=[], _10rwn=[], _10rwl, _10v=[], _10p=[], _10dtl, _10dtp, _10df, _10fsd=[], _12, _13, _14, _14i0, _14s0 = [], _15, _11, _16, _17, _17i0, _17s0 = [];
		this.pe = [{xe:1,Rc:3,Sc:2,renderStyleIndex:0}];
		this.name = "Tale";

		this.ud = function(Bd) {
			Bd.ed();
			Bd._8 = [
				[
					[-1,-1,-1],
					[1,1,1]
				]
			];
			Bd._14 = [
				[
					[0,0.155387,0.267596,0.364789,0.452615,0.533328,0.608007,0.677175,0.741022,0.799497,0.852328,0.899014,0.938752,0.970314,0.991785,1,1]
				]
			];
			Bd._17 = [
				[
					[0,1,1],
					[1,1,1],
					[1,0,0]
				]
			];
			Bd.jd = 500;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.rd = 40;
			vd.Gb = 1;
			vd.Jb = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.rd = 40;
		}

		this.fd = function(Bd, Xb) {
			Xb.Mc=[];
			Xb._ = 0.0;
			Xb._1 = [];
			ctx.rb(Xb._1, [0,0,0], Bd.Mc);
			ctx.c(Xb._1, Bd.Ab, Xb._1);
			Xb._2 = [];
			ctx.T(Xb._2, [0,0,0]);
			ctx.Q(_3y, Bd.ad);
			ctx.I(_3x, _3y, [0,0,1]);
			ctx.Q(_3x, _3x);
			ctx.I(_3z, _3x, _3y);
			ctx.pb(_3, _3x, _3y, _3z);
			Xb._4 = [];
			ctx.U(Xb._4, _3);
			_5 = 0 + Bd.Ld.rand() * (6 - 0);
			Xb._6 = _5;
			_7 = 0 + Bd.Ld.rand() * (1 - 0);
			_8i0=(_7<0?0:(_7>1?1:_7));
			_8i0<0.5?ctx.V(_8s0,0,(_8i0-0)*2):ctx.V(_8s0,1,(_8i0-0.5)*2);
			_8 = Db.nb(Bd._8[0][_8s0[0]],_8s0[1]);
			Xb._9 = _8;
			ctx.T(Xb.Ab, Xb._1);
		}

		this.gd = function(Bd, Xb) {
			Xb.Mc=[];
			Xb._ = 0.0;
			Xb._1 = [];
			ctx.rb(Xb._1, [0,0,0], Bd.Mc);
			ctx.c(Xb._1, Bd.Ab, Xb._1);
			Xb._2 = [];
			ctx.T(Xb._2, [0,0,0]);
			ctx.Q(_3y, Bd.ad);
			ctx.I(_3x, _3y, [0,0,1]);
			ctx.Q(_3x, _3x);
			ctx.I(_3z, _3x, _3y);
			ctx.pb(_3, _3x, _3y, _3z);
			Xb._4 = [];
			ctx.U(Xb._4, _3);
			_5 = 0 + Bd.Ld.rand() * (6 - 0);
			Xb._6 = _5;
			_7 = 0 + Bd.Ld.rand() * (1 - 0);
			_8i0=(_7<0?0:(_7>1?1:_7));
			_8i0<0.5?ctx.V(_8s0,0,(_8i0-0)*2):ctx.V(_8s0,1,(_8i0-0.5)*2);
			_8 = Db.nb(Bd._8[0][_8s0[0]],_8s0[1]);
			Xb._9 = _8;
			ctx.T(Xb.Ab, Xb._1);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			ctx.T(_10fs, [0,0,0]);
			ctx.T(_10vs, [0,0,0]);
			ctx.u(_10v, _10fs, Qb);
			ctx.c(_10v, _10v, Xb._2);
			ctx.u(_10p, _10v, Qb);
			ctx.c(_10p, _10p, Xb._1);
			ctx.T(Xb._1, _10p);
			ctx.T(Xb._2, _10v);
			ctx.T(Xb.Ab, Xb._1);
			_12 = 0.7;
			_13 = (Xb._ / _12);
			_14i0=(_13<0?0:(_13>1?1:_13));
			ctx.V(_14s0,0,(_14i0-0)*15);
			_14 = Db.nb(Bd._14[0][_14s0[0]],_14s0[1]);
			_15 = ctx.r([(Xb._9 * 100), 115], _14);
			_11 = 4;
			_16 = (Xb._ / _11);
			_17i0=(_16<0?0:(_16>1.02523?1.02523:_16));
			_17i0<0.4?_17i0<0.0308411?ctx.V(_17s0,0,(_17i0-0)*32.4242):ctx.V(_17s0,1,(_17i0-0.0308411)*2.70886):ctx.V(_17s0,2,(_17i0-0.4)*1.5994);
			_17 = Db.nb(Bd._17[0][_17s0[0]],_17s0[1]);
			ctx.S(Xb.Pd,[0.5,0.1]);
			ctx.U(Xb.Mc, Xb._4);
			ctx.S(Xb.Nd,_15);
			ctx.T(Xb.gf,[1,1,1]);
			Xb.Od = _17;
			Xb.Qc = Xb._6;
		}

		this.Cc = function(Bd, Xb, Wc) {
			_11 = 4;
			return Xb._ > _11;
		}


	}

	function Emitter_DefaultEmitter() {

		var _1, _2, _3, _3i0, _3s0 = [], _4 = [], _4i, _4s = [], _5 = [];
		this.pe = [];
		this.name = "DefaultEmitter";

		this.ud = function(Bd) {
			Bd.dd();
			Bd._3 = [
				[
					[0,1,1]
				]
			];
			Bd._4 = [
				[[177,80],[169.529,105.73],[164.378,132.025],[161.362,158.651],[160.36,185.429],[161.31,212.209],[164.205,238.849],[169.098,265.194],[176.102,291.058],[185.4,316.186],[197.244,340.213],[211.953,362.595],[229.847,382.508],[251.076,398.794],[275.306,410.114],[301.5,415.5],[301.5,415.5]],
				[[301.5,415.5],[327.152,415.578],[352.085,409.791],[373.605,396.063],[388.709,375.442],[397.624,351.408],[402.362,326.183],[404.566,300.6],[405.313,274.928],[405.362,249.244],[405.362,223.561],[406.017,197.887],[408.342,172.317],[414.19,147.352],[427.183,125.432],[449.5,113.5],[449.5,113.5]],
				[[449.5,113.5],[473.373,111.912],[497.008,115.843],[519.669,123.68],[541.16,134.334],[561.449,147.135],[580.527,161.682],[598.362,177.73],[614.865,195.145],[629.871,213.864],[643.095,233.879],[654.055,255.212],[661.938,277.852],[665.376,301.551],[662.382,325.262],[651.5,346.5],[651.5,346.5]],
				[[651.5,346.5],[641.263,356.197],[628.488,362.167],[614.532,364.333],[600.421,363.449],[586.628,360.3],[573.337,355.437],[560.629,349.205],[548.558,341.812],[537.196,333.37],[526.655,323.924],[517.125,313.461],[508.932,301.926],[502.658,289.254],[499.343,275.531],[500.5,261.5],[500.5,261.5]],
				[[500.5,261.5],[506.473,246.626],[515.012,233.047],[525.337,220.762],[536.954,209.687],[549.558,199.746],[562.952,190.898],[577.009,183.144],[591.637,176.534],[606.769,171.175],[622.333,167.254],[638.231,165.068],[654.272,165.072],[670.047,167.914],[684.716,174.329],[696.958,184.625],[696.958,184.625]],
				[[696.958,184.625],[716.986,212.599],[730.527,244.205],[736.506,278.068],[735.059,312.439],[727.253,345.961],[714.376,377.896],[697.522,407.931],[677.494,435.956],[654.847,461.915],[629.957,485.732],[603.066,507.265],[574.321,526.25],[543.812,542.236],[511.62,554.461],[477.958,561.625],[477.958,561.625]],
				[[477.958,561.625],[448.63,559.696],[421.084,549.226],[396.215,533.344],[373.886,514.027],[353.817,492.364],[335.799,468.963],[319.731,444.18],[305.627,418.23],[293.624,391.244],[284.029,363.315],[277.411,334.539],[274.803,305.144],[278.062,275.855],[290.02,249.033],[311.958,229.625],[311.958,229.625]],
				[[311.958,229.625],[341.606,217.365],[373.185,211.661],[405.289,212.02],[436.948,217.438],[467.655,226.89],[497.192,239.544],[525.488,254.782],[552.522,272.164],[578.287,291.378],[602.762,312.211],[625.899,334.523],[647.602,358.23],[667.714,383.3],[685.975,409.747],[701.958,437.625],[701.958,437.625]],
				[[701.958,437.625],[712.468,460.199],[720.844,483.642],[726.031,507.976],[726.269,532.819],[719.254,556.585],[704.211,576.258],[683.589,590.078],[660.302,598.809],[635.923,603.819],[611.133,606.122],[586.233,606.355],[561.373,604.904],[536.643,601.976],[512.125,597.618],[487.958,591.625],[487.958,591.625]],
				[[487.958,591.625],[462.315,582.822],[437.446,572.016],[413.37,559.539],[390.118,545.586],[367.743,530.265],[346.33,513.628],[326.003,495.68],[306.944,476.392],[289.412,455.709],[273.78,433.558],[260.579,409.884],[250.548,384.711],[244.645,358.276],[243.896,331.213],[248.958,304.625],[248.958,304.625]],
				[[248.958,304.625],[260.734,274.743],[276.638,246.832],[295.933,221.141],[317.954,197.74],[342.164,176.604],[368.138,157.676],[395.552,140.899],[424.153,126.235],[453.742,113.681],[484.152,103.273],[515.235,95.0956],[546.847,89.2894],[578.824,86.0644],[610.958,85.7133],[642.958,88.625],[642.958,88.625]],
				[[642.958,88.625],[670.371,99.3609],[688.706,122.316],[694.812,151.213],[691.219,180.627],[680.692,208.37],[665.034,233.591],[645.445,255.911],[622.822,275.159],[597.881,291.299],[571.214,304.4],[543.307,314.606],[514.553,322.111],[485.266,327.133],[455.675,329.898],[425.958,330.625],[425.958,330.625]],
				[[425.958,330.625],[405.125,328.472],[385.13,322.247],[366.773,312.166],[350.645,298.798],[337.076,282.833],[326.211,264.913],[318.128,245.576],[312.928,225.273],[310.777,204.427],[311.937,183.506],[316.736,163.116],[325.464,144.084],[338.144,127.431],[354.291,114.113],[372.958,104.625],[372.958,104.625]],
				[[372.958,104.625],[394.51,99.1667],[416.733,97.9534],[438.918,99.8733],[460.767,104.199],[482.137,110.484],[502.935,118.461],[523.072,127.987],[542.429,139.01],[560.834,151.557],[578.011,165.735],[593.499,181.733],[606.483,199.807],[615.502,220.12],[618.265,242.12],[612.958,263.625],[612.958,263.625]],
				[[612.958,263.625],[597.601,292.512],[579.239,319.596],[558.517,344.924],[535.852,368.533],[511.521,390.422],[485.706,410.54],[458.533,428.781],[430.088,444.966],[400.442,458.825],[369.677,469.971],[337.925,477.861],[305.449,481.76],[272.766,480.755],[240.811,473.9],[210.958,460.625],[210.958,460.625]],
				[[210.958,460.625],[187.215,444.57],[166.942,424.371],[153.799,399.065],[151.69,370.652],[159.232,343.066],[172.294,317.557],[188.184,293.683],[205.492,270.81],[223.391,248.392],[241.265,225.956],[258.509,203.033],[274.326,179.111],[287.42,153.615],[295.463,126.153],[294.958,97.6251],[294.958,97.6251]],
				[[294.958,97.625],[290.349,84.5982],[282.923,72.9232],[273.656,62.6366],[263.151,53.6086],[251.768,45.7133],[239.725,38.8663],[227.159,33.0331],[214.164,28.2295],[200.814,24.5285],[187.18,22.0762],[173.363,21.1239],[159.553,22.0802],[146.169,25.568],[134.136,32.3365],[124.958,42.625],[124.958,42.625]],
				[[124.958,42.625],[118.71,56.4948],[115.682,71.4176],[115.267,86.6497],[116.918,101.802],[120.241,116.681],[124.974,131.174],[130.957,145.199],[138.097,158.672],[146.359,171.486],[155.756,183.491],[166.341,194.462],[178.191,204.043],[191.372,211.68],[205.794,216.539],[220.958,217.625],[220.958,217.625]],
				[[220.958,217.625],[236.414,214.511],[250.795,208.015],[263.811,199.075],[275.456,188.401],[285.806,176.463],[294.933,163.563],[302.876,149.903],[309.631,135.617],[315.145,120.808],[319.303,105.564],[321.911,89.9809],[322.667,74.2029],[321.133,58.488],[316.739,43.3342],[308.958,29.625],[308.958,29.625]],
				[[308.958,29.625],[301.697,21.2362],[293.264,14.0369],[283.664,8.49685],[273.128,5.0672],[262.101,3.96676],[251.072,5.08222],[240.395,8.08315],[230.264,12.6018],[220.761,18.3308],[211.924,25.044],[203.783,32.5859],[196.383,40.8566],[189.811,49.7989],[184.232,59.3903],[179.958,69.625],[179.958,69.625]]
			];
			Bd.uc(new Emitter_Tale(), { xc: 1, sd: false });
			Bd.jd = 1;
			Bd.Vc = 0;
		}

		this.Mb = function(vd) {
			vd.zb = 0.1;
			vd.Gb = 1;
			vd.Jb = 1;
			vd.Ib = 1;
		}

		this.Pb = function(Qb, Bd, vd) {
			vd.zb = 0.1;
		}

		this.fd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 40;
			_2 = (Xb._ / _1);
			_3i0=(_2<0?0:(_2>1?(0+((_2-0)%1)):_2));
			ctx.V(_3s0,0,(_3i0-0)*1);
			_3 = Db.nb(Bd._3[0][_3s0[0]],_3s0[1]);
			_4i = Db.kb(_3);
			_4i<0.533828?_4i<0.223416?_4i<0.160134?_4i<0.109877?_4i<0.0561683?ctx.V(_4s,0,(_4i-0)*267.055):ctx.V(_4s,1,(_4i-0.0561683)*279.285):ctx.V(_4s,2,(_4i-0.109877)*298.466):_4i<0.189777?ctx.V(_4s,3,(_4i-0.160134)*506.026):ctx.V(_4s,4,(_4i-0.189777)*445.905):_4i<0.424826?_4i<0.357449?_4i<0.295616?ctx.V(_4s,5,(_4i-0.223416)*207.757):ctx.V(_4s,6,(_4i-0.295616)*242.589):ctx.V(_4s,7,(_4i-0.357449)*222.626):_4i<0.476983?ctx.V(_4s,8,(_4i-0.424826)*287.594):ctx.V(_4s,9,(_4i-0.476983)*263.876):_4i<0.822604?_4i<0.707333?_4i<0.663405?_4i<0.601223?ctx.V(_4s,10,(_4i-0.533828)*222.571):ctx.V(_4s,11,(_4i-0.601223)*241.227):ctx.V(_4s,12,(_4i-0.663405)*341.463):_4i<0.753995?ctx.V(_4s,13,(_4i-0.707333)*321.461):ctx.V(_4s,14,(_4i-0.753995)*218.629):_4i<0.943622?_4i<0.91167?_4i<0.882647?ctx.V(_4s,15,(_4i-0.822604)*249.824):ctx.V(_4s,16,(_4i-0.882647)*516.824):ctx.V(_4s,17,(_4i-0.91167)*469.451):_4i<0.976739?ctx.V(_4s,18,(_4i-0.943622)*452.938):ctx.V(_4s,19,(_4i-0.976739)*644.864);
			Db.lb(_4, Bd._4[_4s[0]], _4s[1]);
			ctx.W(_5, _4[0], _4[1], 0);
			ctx.T(Xb.Ab, _5);
		}

		this.gd = function(Bd, Xb) {
			Xb._ = 0.0;
			_1 = 40;
			_2 = (Xb._ / _1);
			_3i0=(_2<0?0:(_2>1?(0+((_2-0)%1)):_2));
			ctx.V(_3s0,0,(_3i0-0)*1);
			_3 = Db.nb(Bd._3[0][_3s0[0]],_3s0[1]);
			_4i = Db.kb(_3);
			_4i<0.533828?_4i<0.223416?_4i<0.160134?_4i<0.109877?_4i<0.0561683?ctx.V(_4s,0,(_4i-0)*267.055):ctx.V(_4s,1,(_4i-0.0561683)*279.285):ctx.V(_4s,2,(_4i-0.109877)*298.466):_4i<0.189777?ctx.V(_4s,3,(_4i-0.160134)*506.026):ctx.V(_4s,4,(_4i-0.189777)*445.905):_4i<0.424826?_4i<0.357449?_4i<0.295616?ctx.V(_4s,5,(_4i-0.223416)*207.757):ctx.V(_4s,6,(_4i-0.295616)*242.589):ctx.V(_4s,7,(_4i-0.357449)*222.626):_4i<0.476983?ctx.V(_4s,8,(_4i-0.424826)*287.594):ctx.V(_4s,9,(_4i-0.476983)*263.876):_4i<0.822604?_4i<0.707333?_4i<0.663405?_4i<0.601223?ctx.V(_4s,10,(_4i-0.533828)*222.571):ctx.V(_4s,11,(_4i-0.601223)*241.227):ctx.V(_4s,12,(_4i-0.663405)*341.463):_4i<0.753995?ctx.V(_4s,13,(_4i-0.707333)*321.461):ctx.V(_4s,14,(_4i-0.753995)*218.629):_4i<0.943622?_4i<0.91167?_4i<0.882647?ctx.V(_4s,15,(_4i-0.822604)*249.824):ctx.V(_4s,16,(_4i-0.882647)*516.824):ctx.V(_4s,17,(_4i-0.91167)*469.451):_4i<0.976739?ctx.V(_4s,18,(_4i-0.943622)*452.938):ctx.V(_4s,19,(_4i-0.976739)*644.864);
			Db.lb(_4, Bd._4[_4s[0]], _4s[1]);
			ctx.W(_5, _4[0], _4[1], 0);
			ctx.T(Xb.Ab, _5);
		}

		this.qc = function(Qb, Bd, Xb) {
			Xb._ += Qb;
			_1 = 40;
			_2 = (Xb._ / _1);
			_3i0=(_2<0?0:(_2>1?(0+((_2-0)%1)):_2));
			ctx.V(_3s0,0,(_3i0-0)*1);
			_3 = Db.nb(Bd._3[0][_3s0[0]],_3s0[1]);
			_4i = Db.kb(_3);
			_4i<0.533828?_4i<0.223416?_4i<0.160134?_4i<0.109877?_4i<0.0561683?ctx.V(_4s,0,(_4i-0)*267.055):ctx.V(_4s,1,(_4i-0.0561683)*279.285):ctx.V(_4s,2,(_4i-0.109877)*298.466):_4i<0.189777?ctx.V(_4s,3,(_4i-0.160134)*506.026):ctx.V(_4s,4,(_4i-0.189777)*445.905):_4i<0.424826?_4i<0.357449?_4i<0.295616?ctx.V(_4s,5,(_4i-0.223416)*207.757):ctx.V(_4s,6,(_4i-0.295616)*242.589):ctx.V(_4s,7,(_4i-0.357449)*222.626):_4i<0.476983?ctx.V(_4s,8,(_4i-0.424826)*287.594):ctx.V(_4s,9,(_4i-0.476983)*263.876):_4i<0.822604?_4i<0.707333?_4i<0.663405?_4i<0.601223?ctx.V(_4s,10,(_4i-0.533828)*222.571):ctx.V(_4s,11,(_4i-0.601223)*241.227):ctx.V(_4s,12,(_4i-0.663405)*341.463):_4i<0.753995?ctx.V(_4s,13,(_4i-0.707333)*321.461):ctx.V(_4s,14,(_4i-0.753995)*218.629):_4i<0.943622?_4i<0.91167?_4i<0.882647?ctx.V(_4s,15,(_4i-0.822604)*249.824):ctx.V(_4s,16,(_4i-0.882647)*516.824):ctx.V(_4s,17,(_4i-0.91167)*469.451):_4i<0.976739?ctx.V(_4s,18,(_4i-0.943622)*452.938):ctx.V(_4s,19,(_4i-0.976739)*644.864);
			Db.lb(_4, Bd._4[_4s[0]], _4s[1]);
			ctx.W(_5, _4[0], _4[1], 0);
			ctx.T(Xb.Ab, _5);
		}

		this.Cc = function(Bd, Xb, Wc) {
			return 0 > 1;
		}


	}

	this.qd = function(Ld) {
		Ld.Dd = 0.0333333;
		Ld.Ud = 0;
		Ld.rand = function() { return Math.random(); };
		Ld.pd(new Emitter_Tale());
		Ld.pd(new Emitter_DefaultEmitter());
	}
			this.kb = function (v) { 				return (v < 0) ? 0 : ((v > 1) ? 1 : v); 			}

			this.lb = function (r, path, je) { 				var indexInt = Math.floor(je); 				var lerp = je - indexInt; 				ctx.Y(r, path[indexInt], path[indexInt + 1], lerp); 			}

			this.nb = function(funcValues, je) { 				var indexInt = Math.floor(je); 				var nextInt = indexInt + 1; 				return ctx.X(funcValues[indexInt], funcValues[nextInt], je - indexInt); 			}

}
